//宏定义:数据长度
# define APEN_DATA_LEN 							250
//宏定义：数据分析维度
# define APEN_DIMENSION_M						2 
# define APEN_DIMENSION_M1						(APEN_DIMENSION_M + 1)
# define APEN_MD_LEN							(APEN_DATA_LEN - APEN_DIMENSION_M + 1)
# define APEN_M1D_LEN							(APEN_DATA_LEN - APEN_DIMENSION_M1 + 1)

//宏定义：硬件加速距离计算函数的乘法系数
# define MULT_PAR_M		4211
# define MULT_PAR_M1	4228

//用户API接口函数(返回值为近似熵,prop为比例,buff为要处理的数组)
float ApEn_Calculate(float Prop, int* buff, int nicech);




//工具函数: 初始化算法
void ApEn_Algorithm_Init(float Prop, int* buff); 
//工具函数：计算标准差 
float ApEn_STD_Deviation(int* buff, unsigned int len);
//工具函数：重构数组
void ApEn_Restructure(int* buff, unsigned int len);
//工具函数: 计算m维度向量距离(Vec为一维数组,m为维度)
int ApEn_Calculate_Distance(int* Vec1, int* Vec2, unsigned int m);
//工具函数：计算所有向量的距离
void ApEn_Calculate_All_Distance(void);
//工具函数：使用nice协处理器计算各向量距离
void ApEn_Calculate_All_Distance_Nice(unsigned int buffAddr);
//工具函数：对向量距离数组求对数平均值
void ApEn_Calculate_ln_AVR(void);
//工具函数：使用nice协处理器对向量距离数组求对数平均值
void ApEn_Calculate_ln_AVR_Nice(void);
//工具函数：算数平均值结果相减
void ApEn_Sub_Result(void);


//内存单元:用于计算的m维数组
extern int ApEn_MD_Buff[APEN_MD_LEN][APEN_DIMENSION_M];
//内存单元:用于计算的m+1维数组
extern int ApEn_M1D_Buff[APEN_M1D_LEN][APEN_DIMENSION_M1];
//内存单元:m维度的向量组的距离
extern float ApEn_DsitanceAll_m[APEN_MD_LEN];
//内存单元:m+1维度的向量组的距离
extern float ApEn_DsitanceAll_m1[APEN_M1D_LEN];

//变量：标准差 
extern float ApEn_StdVal;
//变量: 标准差比例
extern float ApEn_StdProp;
//变量: 阈值
extern float ApEn_Threshold;
//变量：m维距离对数平均值
extern float ApEn_DistLnAVR_m;
//变量：m+1维距离对数平均值
extern float ApEn_DistLnAVR_m1;
//变量：计算结果
extern float ApEn_Result; 
