# include "cnn_top.h"
# include "insn.h"
# ifdef PRINTF_INFO
# include "stdio.h"
# endif

/*
// if define CNN_NICE_USE, replace the function.
# ifdef CNN_NICE_USE
# define Conv_LoadKernel				Conv_LoadKernel_Nice
# define Conv_RunningConvolution		Conv_RunningConvolution_Nice
# endif
*/

//Run all layer 
void CNN_RunAllLayer_inst(CNN_NET* Net_inst)
{
	int i = 0, j = 0,layers = 0;
	int result_nums = 0;
	# ifdef PRINTF_INFO
		printf("#Parameter is : \n");
		printf("Layer Amount = %d\n", Net_inst->LayerAmount);
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			printf("kernel Amount[%d] = %d\n", i, Net_inst->kernelAmount[i]);
		}
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			printf("kernel Length[%d] = %d\n", i, Net_inst->kernelLen[i]);
		}
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			if(Net_inst->kernelLen[i] == 0)
				printf("Poolling Mode[%d] = %d\n", i, Net_inst->PoollingMode[i]);
		}
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			printf("Padding Amount[%d] = %d\n", i, Net_inst->PaddingAmount[i]);
		}
		printf("OriginalData[%d] = [", Net_inst->OriginalDatalen);
		for(i = 0; i < Net_inst->OriginalDatalen; ++i){
			printf("%f, ", Net_inst->pOriginalData[i]);
		}
		printf("]\n");
		printf("\n==========================Start running CNN==========================\n");
	# endif
	//run layer
	for(layers = 0; layers < Net_inst->LayerAmount; ++layers){
		//i = 0, the first layer.
		if(layers == 0){
			# ifdef PRINTF_INFO
				printf("\n===========================Running Layer 0===========================\n");
			# endif
			//calculate for every kernel
			//set padding
			Conv_SetPaddingLen(Net_inst->PaddingAmount[0]);
			//load kernel
			if(!Conv_LoadKernel(Net_inst->Kernel0BuffStartAddr[0], Net_inst->kernelLen[0])){
				# ifdef PRINTF_INFO
					printf("*Load kernel data sucess!\n");
				# endif
			}
			else{
				# ifdef PRINTF_INFO
					printf("*Load kernel data failed!\n");
				# endif
			}
			# ifdef PRINTF_INFO
				printf("#Data in the ConvKernelCache is : \n");
				for(i = 0; i < ConvKernelSize; ++i){
					printf("%f, ", ConvKernelCache[i]);
				}
				printf("\n");
			# endif
			//load original data
			if(!Conv_LoadOriSeqToCache(Net_inst->pOriginalData, Net_inst->OriginalDatalen)){
				# ifdef PRINTF_INFO
					printf("*Load original data sucess\n");
				# endif
			}
			else{
				# ifdef PRINTF_INFO
					printf("*Load original data failed!\n");
				# endif
			}
			# ifdef PRINTF_INFO
				printf("#Data in the ConvCache is : \n");
				for(i = 0; i < ConvSeqLen; ++i){
					printf("%f, ", ConvCache0[i]);
				}
				printf("\n");
			# endif
			//clear buff
			Conv_ClearConvCache(); 
			//reset padding
			Conv_SetPaddingLen(Net_inst->PaddingAmount[1]);
			//run layer's Convolution
			if(!Conv_RunningConvolution(0)){
				# ifdef PRINTF_INFO
					printf("*Convolution was Calulated sucess!\n");
				# endif
			}
			else{
				# ifdef PRINTF_INFO
					printf("*Convolution was Calulated failed!\n");
				# endif
			}
			for(j = 1; j < Net_inst->kernelAmount[0]; ++j){
				//reload kernels
				if(!Conv_LoadKernel((CALU_TYPE*)(Net_inst->Kernel0BuffStartAddr[0] + (j * Net_inst->kernelLen[0])), Net_inst->kernelLen[0])){
					# ifdef PRINTF_INFO
						printf("*Load kernel data sucess!\n");
					# endif
				}
				else{
					# ifdef PRINTF_INFO
						printf("*Load kernel data failed!\n");
					# endif
				}
				# ifdef PRINTF_INFO
					printf("#Data in the ConvKernelCache is : \n");
					for(i = 0; i < ConvKernelSize; ++i){
						printf("%f, ", ConvKernelCache[i]);
					}
					printf("\n");
				# endif
				//run layer's Convolution
				Conv_RunningConvolution(0);
			}
			//Reset the sequence length.
			Conv_SetSeqLen(ConvCachePos/Net_inst->kernelAmount[0]); 
			//end the layer
			Conv_LayerEnd();
			//updata result nums
			result_nums = Net_inst->kernelAmount[0];
			# ifdef PRINTF_INFO
				printf("#Total: %d datas,Result:\n",ConvCachePos);
				for(i = 0; i < ConvCachePos; ++i){
					printf("%f, ",ConvCache1[i]);
					if((i+1) % (ConvCachePos/result_nums) == 0){
						printf("\n----------------------------------------------------------------------\n");
					}
				}
			# endif
		}
		else{
			# ifdef PRINTF_INFO
				printf("\n===========================Running Layer %d===========================\n", layers);
			# endif
			//if Net_inst->kernelAmount[i] = 0, it is a pooling layer
			if(Net_inst->kernelAmount[layers] == 0){
				# ifdef PRINTF_INFO
					printf("Net_inst->PoollingMode[%d] = %d, Net_inst->kernelLen[%d] = %d\n", layers,Net_inst->PoollingMode[layers], layers,Net_inst->kernelLen[layers]);
				# endif
				//run pooling. 
				Conv_RunningPooling(Net_inst->PoollingMode[layers], Net_inst->kernelLen[layers]);
				# ifdef PRINTF_INFO
					printf("#Total: %d datas,Result:\n", ConvCachePos); 
					for(i = 0; i < ConvCachePos; ++i){
						printf("%f, ",ConvCache0[i]);
						if((i+1) % (ConvCachePos/result_nums) == 0){
							printf("\n----------------------------------------------------------------------\n");
						}
					}	
					printf("\n");
				# endif				
				//end the layer
				Conv_LayerEnd();
			}
			//else it is a convolution layer 
			else{
				//Reset the Cache 
				Conv_ClearConvCache(); 
				//reset the num of padding
				Conv_SetPaddingLen(Net_inst->PaddingAmount[layers]);
				for(i = 0; i < Net_inst->kernelAmount[layers]; ++i){
					//Load kernel
					if(!Conv_LoadKernel((CALU_TYPE*)(Net_inst->Kernel0BuffStartAddr[layers] + (i * Net_inst->kernelLen[layers])), Net_inst->kernelLen[layers])){
						# ifdef PRINTF_INFO
							printf("\n*Load kernel data sucess!");
						# endif
					}
					else{
						# ifdef PRINTF_INFO
						printf("\n*Load kernel data failed!\n");
						# endif	
					}
					# ifdef PRINTF_INFO
						printf("#Data in the ConvKernelCache is : \n");
						for(j = 0; j < ConvKernelSize; ++j){
							printf("%f, ", ConvKernelCache[j]);
						}
						printf("\n");
					# endif
					for(j = 0; j < result_nums; ++j){
						if(Conv_RunningConvolution(j*ConvSeqLen)){
							# ifdef PRINTF_INFO
								printf("*Convolution was Calulated failed!");
							# endif
						}
					}
				}
				//updata result nums
				result_nums = result_nums * Net_inst->kernelAmount[layers];
				//Reset the sequence length.
				Conv_SetSeqLen(ConvCachePos/result_nums); 
				//end the layer
				Conv_LayerEnd();
				# ifdef PRINTF_INFO
					printf("#Total: %d datas,Result:\n",ConvCachePos);
					for(i = 0; i < ConvCachePos; ++i){
						printf("%f, ",ConvCache1[i]);
						if((i+1) % (ConvCachePos/result_nums) == 0){
							printf("\n----------------------------------------------------------------------\n");
						}
					}
				# endif
			}
		}
	}
	
	# ifdef PRINTF_INFO
		printf("\n=========================Finish running CNN=========================\n");
	# endif
}

//Run all layer
void CNN_RunAllLayer_inst_Nice(CNN_NET* Net_inst)
{
	int i = 0, j = 0,layers = 0;
	int result_nums = 0;
	# ifdef PRINTF_INFO
		printf("#Parameter is : \n");
		printf("Layer Amount = %d\n", Net_inst->LayerAmount);
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			printf("kernel Amount[%d] = %d\n", i, Net_inst->kernelAmount[i]);
		}
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			printf("kernel Length[%d] = %d\n", i, Net_inst->kernelLen[i]);
		}
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			if(Net_inst->kernelLen[i] == 0)
				printf("Poolling Mode[%d] = %d\n", i, Net_inst->PoollingMode[i]);
		}
		for(i = 0;i < Net_inst->LayerAmount; ++i){
			printf("Padding Amount[%d] = %d\n", i, Net_inst->PaddingAmount[i]);
		}
		printf("OriginalData[%d] = [", Net_inst->OriginalDatalen);
		for(i = 0; i < Net_inst->OriginalDatalen; ++i){
			printf("%f, ", Net_inst->pOriginalData[i]);
		}
		printf("]\n");
		printf("\n==========================Start running CNN==========================\n");
	# endif
	//run layer
	for(layers = 0; layers < Net_inst->LayerAmount; ++layers){
		//i = 0, the first layer.
		if(layers == 0){
			# ifdef PRINTF_INFO
				printf("\n===========================Running Layer 0===========================\n");
			# endif
			//calculate for every kernel
			//set padding
			Conv_SetPaddingLen(Net_inst->PaddingAmount[0]);
			//load kernel
			if(!Conv_LoadKernel_Nice(Net_inst->Kernel0BuffStartAddr[0], Net_inst->kernelLen[0])){
				# ifdef PRINTF_INFO
					printf("*Load kernel data sucess!\n");
				# endif
			}
			else{
				# ifdef PRINTF_INFO
					printf("*Load kernel data failed!\n");
				# endif
			}
			# ifdef PRINTF_INFO
				printf("#Data in the ConvKernelCache is : \n");
				for(i = 0; i < ConvKernelSize; ++i){
					printf("%f, ", ConvKernelCache[i]);
				}
				printf("\n");
			# endif
			//load original data
			if(!Conv_LoadOriSeqToCache(Net_inst->pOriginalData, Net_inst->OriginalDatalen)){
				# ifdef PRINTF_INFO
					printf("*Load original data sucess\n");
				# endif
			}
			else{
				# ifdef PRINTF_INFO
					printf("*Load original data failed!\n");
				# endif
			}
			# ifdef PRINTF_INFO
				printf("#Data in the ConvCache is : \n");
				for(i = 0; i < ConvSeqLen; ++i){
					printf("%f, ", ConvCache0[i]);
				}
				printf("\n");
			# endif
			//clear buff
			Conv_ClearConvCache();
			//reset padding
			Conv_SetPaddingLen(Net_inst->PaddingAmount[1]);
			//run layer's Convolution
			if(!Conv_RunningConvolution_Nice(0)){
				# ifdef PRINTF_INFO
					printf("*Convolution was Calulated sucess!\n");
				# endif
			}
			else{
				# ifdef PRINTF_INFO
					printf("*Convolution was Calulated failed!\n");
				# endif
			}
			for(j = 1; j < Net_inst->kernelAmount[0]; ++j){
				//reload kernels
				if(!Conv_LoadKernel_Nice((CALU_TYPE*)(Net_inst->Kernel0BuffStartAddr[0] + (j * Net_inst->kernelLen[0])), Net_inst->kernelLen[0])){
					# ifdef PRINTF_INFO
						printf("*Load kernel data sucess!\n");
					# endif
				}
				else{
					# ifdef PRINTF_INFO
						printf("*Load kernel data failed!\n");
					# endif
				}
				# ifdef PRINTF_INFO
					printf("#Data in the ConvKernelCache is : \n");
					for(i = 0; i < ConvKernelSize; ++i){
						printf("%f, ", ConvKernelCache[i]);
					}
					printf("\n");
				# endif
				//run layer's Convolution
				Conv_RunningConvolution_Nice(0);
			}
			//Reset the sequence length.
			Conv_SetSeqLen(ConvCachePos/Net_inst->kernelAmount[0]);
			//end the layer
			Conv_LayerEnd();
			//updata result nums
			result_nums = Net_inst->kernelAmount[0];
			# ifdef PRINTF_INFO
				printf("#Total: %d datas,Result:\n",ConvCachePos);
				for(i = 0; i < ConvCachePos; ++i){
					printf("%f, ",ConvCache1[i]);
					if((i+1) % (ConvCachePos/result_nums) == 0){
						printf("\n----------------------------------------------------------------------\n");
					}
				}
			# endif
		}
		else{
			# ifdef PRINTF_INFO
				printf("\n===========================Running Layer %d===========================\n", layers);
			# endif
			//if Net_inst->kernelAmount[i] = 0, it is a pooling layer
			if(Net_inst->kernelAmount[layers] == 0){
				# ifdef PRINTF_INFO
					printf("Net_inst->PoollingMode[%d] = %d, Net_inst->kernelLen[%d] = %d\n", layers,Net_inst->PoollingMode[layers], layers,Net_inst->kernelLen[layers]);
				# endif
				//run pooling.
				Conv_RunningPooling(Net_inst->PoollingMode[layers], Net_inst->kernelLen[layers]);
				# ifdef PRINTF_INFO
					printf("#Total: %d datas,Result:\n", ConvCachePos);
					for(i = 0; i < ConvCachePos; ++i){
						printf("%f, ",ConvCache0[i]);
						if((i+1) % (ConvCachePos/result_nums) == 0){
							printf("\n----------------------------------------------------------------------\n");
						}
					}
					printf("\n");
				# endif
				//end the layer
				Conv_LayerEnd();
			}
			//else it is a convolution layer
			else{
				//Reset the Cache
				Conv_ClearConvCache();
				//reset the num of padding
				Conv_SetPaddingLen(Net_inst->PaddingAmount[layers]);
				for(i = 0; i < Net_inst->kernelAmount[layers]; ++i){
					//Load kernel
					if(!Conv_LoadKernel_Nice((CALU_TYPE*)(Net_inst->Kernel0BuffStartAddr[layers] + (i * Net_inst->kernelLen[layers])), Net_inst->kernelLen[layers])){
						# ifdef PRINTF_INFO
							printf("\n*Load kernel data sucess!");
						# endif
					}
					else{
						# ifdef PRINTF_INFO
						printf("\n*Load kernel data failed!\n");
						# endif
					}
					# ifdef PRINTF_INFO
						printf("#Data in the ConvKernelCache is : \n");
						for(j = 0; j < ConvKernelSize; ++j){
							printf("%f, ", ConvKernelCache[j]);
						}
						printf("\n");
					# endif
					for(j = 0; j < result_nums; ++j){
						if(Conv_RunningConvolution_Nice(j*ConvSeqLen)){
							# ifdef PRINTF_INFO
								printf("*Convolution was Calulated failed!");
							# endif
						}
					}
				}
				//updata result nums
				result_nums = result_nums * Net_inst->kernelAmount[layers];
				//Reset the sequence length.
				Conv_SetSeqLen(ConvCachePos/result_nums);
				//end the layer
				Conv_LayerEnd();
				# ifdef PRINTF_INFO
					printf("#Total: %d datas,Result:\n",ConvCachePos);
					for(i = 0; i < ConvCachePos; ++i){
						printf("%f, ",ConvCache1[i]);
						if((i+1) % (ConvCachePos/result_nums) == 0){
							printf("\n----------------------------------------------------------------------\n");
						}
					}
				# endif
			}
		}
	}

	# ifdef PRINTF_INFO
		printf("\n=========================Finish running CNN=========================\n");
	# endif
}

//calculate relu
void CNN_Calurelu(CALU_TYPE* NetBuff, int len)
{
	int i = 0;
	for(i = 0; i < len; ++i){
			//if(NetBuff[i] < 0.0f){
			if(*(int*)&NetBuff[i] & 0x80000000){
				NetBuff[i] = 0.0f;
		}
	}
}

# ifdef CNN_NICE_USE
//Calculate Full_Connection_Layer
CALU_TYPE CNN_Calculate_Full_Connection_Nice(CALU_TYPE* NetBuff, CALU_TYPE* ParaBuff, int len)
{
	int i = 0;
	CALU_TYPE Value = 0.0f;
	//calculate whole NICE_CONV_PARALLEL_MAX datas
	for(i = 0; i < (len - NICE_CONV_PARALLEL_MAX); i+=NICE_CONV_PARALLEL_MAX){
		# ifdef PRINTF_INFO
			//printf("%f += (%f * %f) \n", Value, NetBuff[i], ParaBuff[i]);
		# endif
		custom_cnn_load_kernel((unsigned int)&ParaBuff[i], NICE_CONV_PARALLEL_MAX);
		Value += custom_cnn_calculate((unsigned int)&NetBuff[i]);
	}
	//calculate surplus datas
	for(; i < len; ++i){
		# ifdef PRINTF_INFO
			printf("%f += (%f * %f) \n", Value, NetBuff[i], ParaBuff[i]);
		# endif
		Value += custom_multiply_f(NetBuff[i] , ParaBuff[i]);
	}

	return Value;
}
# endif
//Calculate Full_Connection_Layer
CALU_TYPE CNN_Calculate_Full_Connection(CALU_TYPE* NetBuff, CALU_TYPE* ParaBuff, int len)
{
	int i = 0;
	CALU_TYPE Value = 0;
	for(i = 0; i < len; ++i){
		# ifdef PRINTF_INFO
			//printf("%f += (%f * %f) \n", Value, NetBuff[i], ParaBuff[i]);
		# endif
		Value += (NetBuff[i] * ParaBuff[i]);
		//Value += custom_multiply_f(NetBuff[i] , ParaBuff[i]);
	}
	return Value;
}



/*
//Initial functiona
void InitCNNNet(CNN_NET* Net_inst)
{
	Net_inst->RunAllLayer = RunAllLayer_inst;
}
*/
