# ifndef __CNN_DATA_H_
# define __CNN_DATA_H_
# include "convolution.h"

//Comment CNN_NICE_USE, program will not use nice coprocessor.
# define CNN_NICE_USE

//Define the ability of parallel computing.
# ifdef CNN_NICE_USE
# define NICE_CONV_PARALLEL_MAX		15
# endif

//Comment CNN_NICE_USE, program will not print the debug info.
//# define PRINTF_INFO


//The max layer amount of cnn.(convolution layer and pooling layer)
# define CNN_LAYER_MAX	16


//CNN net information 
typedef struct CNN_NET
{
	//Basic information
	int LayerAmount;						//the amount of the cnn.Max Amount is 16.
	int kernelAmount[CNN_LAYER_MAX];		//This buff store the amount of every layer's convolution kernels,if layer is pooling layer, write 0.
	int kernelLen[CNN_LAYER_MAX];			//This buff store the length of every layer's convolution kernels,if layer is pooling layer, it is pooling length.
	int PoollingMode[CNN_LAYER_MAX];		//This buff store the number of pooling mode for exery layer.if this layer isn't a pooling layer, don't care.
	int PaddingAmount[CNN_LAYER_MAX];		//This buff store the number of padding for next layer.
	CALU_TYPE* pOriginalData;				//The Point for Original_Data.
	int OriginalDatalen;					//Original_Data length.
	//Additional information
	CALU_TYPE* Kernel0BuffStartAddr[CNN_LAYER_MAX];			//2d array start addr
	
}CNN_NET;


//Run all layer 
void CNN_RunAllLayer_inst(CNN_NET* Net_inst);
# ifdef CNN_NICE_USE
void CNN_RunAllLayer_inst_Nice(CNN_NET* Net_inst);
# endif
//calculate relu
void CNN_Calurelu(CALU_TYPE* NetBuff, int len);
//Calculate Full_Connection_Layer
CALU_TYPE CNN_Calculate_Full_Connection(CALU_TYPE* NetBuff, CALU_TYPE* ParaBuff, int len);
# ifdef CNN_NICE_USE
//Calculate Full_Connection_Layer
CALU_TYPE CNN_Calculate_Full_Connection_Nice(CALU_TYPE* NetBuff, CALU_TYPE* ParaBuff, int len);
# endif














# endif
